//! This is a test of the aes128 mini-lib. Tests have been based upon test vectors from the NIST USA, available from
//! [the NIST website](https://csrc.nist.gov/groups/STM/cavp/documents/aes/KAT_AES.zip)
//!
//! # Test vectors
//!
//! ## ECB Vary Key
//!
//! assert eval(0x00000000000000000000000000000000, 0x80000000000000000000000000000000) => 0x0edd33d3c621e546455bd8ba1418bec8
//! assert eval(0x00000000000000000000000000000000, 0xc0000000000000000000000000000000) => 0x4bc3f883450c113c64ca42e1112a9e87
//! assert eval(0x00000000000000000000000000000000, 0xe0000000000000000000000000000000) => 0x72a1da770f5d7ac4c9ef94d822affd97
//! assert eval(0x00000000000000000000000000000000, 0xf0000000000000000000000000000000) => 0x970014d634e2b7650777e8e84d03ccd8
//! assert eval(0x00000000000000000000000000000000, 0xf8000000000000000000000000000000) => 0xf17e79aed0db7e279e955b5f493875a7
//! assert eval(0x00000000000000000000000000000000, 0xfc000000000000000000000000000000) => 0x9ed5a75136a940d0963da379db4af26a
//! assert eval(0x00000000000000000000000000000000, 0xfe000000000000000000000000000000) => 0xc4295f83465c7755e8fa364bac6a7ea5
//! assert eval(0x00000000000000000000000000000000, 0xff000000000000000000000000000000) => 0xb1d758256b28fd850ad4944208cf1155
//! assert eval(0x00000000000000000000000000000000, 0xff800000000000000000000000000000) => 0x42ffb34c743de4d88ca38011c990890b
//! assert eval(0x00000000000000000000000000000000, 0xffc00000000000000000000000000000) => 0x9958f0ecea8b2172c0c1995f9182c0f3
//! assert eval(0x00000000000000000000000000000000, 0xffe00000000000000000000000000000) => 0x956d7798fac20f82a8823f984d06f7f5
//! assert eval(0x00000000000000000000000000000000, 0xfff00000000000000000000000000000) => 0xa01bf44f2d16be928ca44aaf7b9b106b
//! assert eval(0x00000000000000000000000000000000, 0xfff80000000000000000000000000000) => 0xb5f1a33e50d40d103764c76bd4c6b6f8
//! assert eval(0x00000000000000000000000000000000, 0xfffc0000000000000000000000000000) => 0x2637050c9fc0d4817e2d69de878aee8d
//! assert eval(0x00000000000000000000000000000000, 0xfffe0000000000000000000000000000) => 0x113ecbe4a453269a0dd26069467fb5b5
//! assert eval(0x00000000000000000000000000000000, 0xffff0000000000000000000000000000) => 0x97d0754fe68f11b9e375d070a608c884
//! assert eval(0x00000000000000000000000000000000, 0xffff8000000000000000000000000000) => 0xc6a0b3e998d05068a5399778405200b4
//! assert eval(0x00000000000000000000000000000000, 0xffffc000000000000000000000000000) => 0xdf556a33438db87bc41b1752c55e5e49
//! assert eval(0x00000000000000000000000000000000, 0xffffe000000000000000000000000000) => 0x90fb128d3a1af6e548521bb962bf1f05
//! assert eval(0x00000000000000000000000000000000, 0xfffff000000000000000000000000000) => 0x26298e9c1db517c215fadfb7d2a8d691
//! assert eval(0x00000000000000000000000000000000, 0xfffff800000000000000000000000000) => 0xa6cb761d61f8292d0df393a279ad0380
//! assert eval(0x00000000000000000000000000000000, 0xfffffc00000000000000000000000000) => 0x12acd89b13cd5f8726e34d44fd486108
//! assert eval(0x00000000000000000000000000000000, 0xfffffe00000000000000000000000000) => 0x95b1703fc57ba09fe0c3580febdd7ed4
//! assert eval(0x00000000000000000000000000000000, 0xffffff00000000000000000000000000) => 0xde11722d893e9f9121c381becc1da59a
//! assert eval(0x00000000000000000000000000000000, 0xffffff80000000000000000000000000) => 0x6d114ccb27bf391012e8974c546d9bf2
//! assert eval(0x00000000000000000000000000000000, 0xffffffc0000000000000000000000000) => 0x5ce37e17eb4646ecfac29b9cc38d9340
//! assert eval(0x00000000000000000000000000000000, 0xffffffe0000000000000000000000000) => 0x18c1b6e2157122056d0243d8a165cddb
//! assert eval(0x00000000000000000000000000000000, 0xfffffff0000000000000000000000000) => 0x99693e6a59d1366c74d823562d7e1431
//! assert eval(0x00000000000000000000000000000000, 0xfffffff8000000000000000000000000) => 0x6c7c64dc84a8bba758ed17eb025a57e3
//! assert eval(0x00000000000000000000000000000000, 0xfffffffc000000000000000000000000) => 0xe17bc79f30eaab2fac2cbbe3458d687a
//! assert eval(0x00000000000000000000000000000000, 0xfffffffe000000000000000000000000) => 0x1114bc2028009b923f0b01915ce5e7c4
//! assert eval(0x00000000000000000000000000000000, 0xffffffff000000000000000000000000) => 0x9c28524a16a1e1c1452971caa8d13476
//! assert eval(0x00000000000000000000000000000000, 0xffffffff800000000000000000000000) => 0xed62e16363638360fdd6ad62112794f0
//! assert eval(0x00000000000000000000000000000000, 0xffffffffc00000000000000000000000) => 0x5a8688f0b2a2c16224c161658ffd4044
//! assert eval(0x00000000000000000000000000000000, 0xffffffffe00000000000000000000000) => 0x23f710842b9bb9c32f26648c786807ca
//! assert eval(0x00000000000000000000000000000000, 0xfffffffff00000000000000000000000) => 0x44a98bf11e163f632c47ec6a49683a89
//! assert eval(0x00000000000000000000000000000000, 0xfffffffff80000000000000000000000) => 0x0f18aff94274696d9b61848bd50ac5e5
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffc0000000000000000000000) => 0x82408571c3e2424540207f833b6dda69
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffe0000000000000000000000) => 0x303ff996947f0c7d1f43c8f3027b9b75
//! assert eval(0x00000000000000000000000000000000, 0xffffffffff0000000000000000000000) => 0x7df4daf4ad29a3615a9b6ece5c99518a
//! assert eval(0x00000000000000000000000000000000, 0xffffffffff8000000000000000000000) => 0xc72954a48d0774db0b4971c526260415
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffc000000000000000000000) => 0x1df9b76112dc6531e07d2cfda04411f0
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffe000000000000000000000) => 0x8e4d8e699119e1fc87545a647fb1d34f
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffff000000000000000000000) => 0xe6c4807ae11f36f091c57d9fb68548d1
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffff800000000000000000000) => 0x8ebf73aad49c82007f77a5c1ccec6ab4
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffc00000000000000000000) => 0x4fb288cc2040049001d2c7585ad123fc
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffe00000000000000000000) => 0x04497110efb9dceb13e2b13fb4465564
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffff00000000000000000000) => 0x75550e6cb5a88e49634c9ab69eda0430
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffff80000000000000000000) => 0xb6768473ce9843ea66a81405dd50b345
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffc0000000000000000000) => 0xcb2f430383f9084e03a653571e065de6
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffe0000000000000000000) => 0xff4e66c07bae3e79fb7d210847a3b0ba
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffff0000000000000000000) => 0x7b90785125505fad59b13c186dd66ce3
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffff8000000000000000000) => 0x8b527a6aebdaec9eaef8eda2cb7783e5
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffc000000000000000000) => 0x43fdaf53ebbc9880c228617d6a9b548b
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffe000000000000000000) => 0x53786104b9744b98f052c46f1c850d0b
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffff000000000000000000) => 0xb5ab3013dd1e61df06cbaf34ca2aee78
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffff800000000000000000) => 0x7470469be9723030fdcc73a8cd4fbb10
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffc00000000000000000) => 0xa35a63f5343ebe9ef8167bcb48ad122e
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffe00000000000000000) => 0xfd8687f0757a210e9fdf181204c30863
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffff00000000000000000) => 0x7a181e84bd5457d26a88fbae96018fb0
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffff80000000000000000) => 0x653317b9362b6f9b9e1a580e68d494b5
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffc0000000000000000) => 0x995c9dc0b689f03c45867b5faa5c18d1
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffe0000000000000000) => 0x77a4d96d56dda398b9aabecfc75729fd
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffff0000000000000000) => 0x84be19e053635f09f2665e7bae85b42d
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffff8000000000000000) => 0x32cd652842926aea4aa6137bb2be2b5e
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffc000000000000000) => 0x493d4a4f38ebb337d10aa84e9171a554
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffe000000000000000) => 0xd9bff7ff454b0ec5a4a2a69566e2cb84
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffff000000000000000) => 0x3535d565ace3f31eb249ba2cc6765d7a
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffff800000000000000) => 0xf60e91fc3269eecf3231c6e9945697c6
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffc00000000000000) => 0xab69cfadf51f8e604d9cc37182f6635a
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffe00000000000000) => 0x7866373f24a0b6ed56e0d96fcdafb877
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffff00000000000000) => 0x1ea448c2aac954f5d812e9d78494446a
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffff80000000000000) => 0xacc5599dd8ac02239a0fef4a36dd1668
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffc0000000000000) => 0xd8764468bb103828cf7e1473ce895073
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffe0000000000000) => 0x1b0d02893683b9f180458e4aa6b73982
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffff0000000000000) => 0x96d9b017d302df410a937dcdb8bb6e43
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffff8000000000000) => 0xef1623cc44313cff440b1594a7e21cc6
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffc000000000000) => 0x284ca2fa35807b8b0ae4d19e11d7dbd7
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffe000000000000) => 0xf2e976875755f9401d54f36e2a23a594
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffff000000000000) => 0xec198a18e10e532403b7e20887c8dd80
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffff800000000000) => 0x545d50ebd919e4a6949d96ad47e46a80
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffc00000000000) => 0xdbdfb527060e0a71009c7bb0c68f1d44
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffe00000000000) => 0x9cfa1322ea33da2173a024f2ff0d896d
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffff00000000000) => 0x8785b1a75b0f3bd958dcd0e29318c521
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffff80000000000) => 0x38f67b9e98e4a97b6df030a9fcdd0104
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffc0000000000) => 0x192afffb2c880e82b05926d0fc6c448b
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffe0000000000) => 0x6a7980ce7b105cf530952d74daaf798c
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffff0000000000) => 0xea3695e1351b9d6858bd958cf513ef6c
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffff8000000000) => 0x6da0490ba0ba0343b935681d2cce5ba1
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffc000000000) => 0xf0ea23af08534011c60009ab29ada2f1
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffe000000000) => 0xff13806cf19cc38721554d7c0fcdcd4b
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffff000000000) => 0x6838af1f4f69bae9d85dd188dcdf0688
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffff800000000) => 0x36cf44c92d550bfb1ed28ef583ddf5d7
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffc00000000) => 0xd06e3195b5376f109d5c4ec6c5d62ced
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffe00000000) => 0xc440de014d3d610707279b13242a5c36
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffff00000000) => 0xf0c5c6ffa5e0bd3a94c88f6b6f7c16b9
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffff80000000) => 0x3e40c3901cd7effc22bffc35dee0b4d9
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffc0000000) => 0xb63305c72bedfab97382c406d0c49bc6
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffe0000000) => 0x36bbaab22a6bd4925a99a2b408d2dbae
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffff0000000) => 0x307c5b8fcd0533ab98bc51e27a6ce461
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffff8000000) => 0x829c04ff4c07513c0b3ef05c03e337b5
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffc000000) => 0xf17af0e895dda5eb98efc68066e84c54
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffe000000) => 0x277167f3812afff1ffacb4a934379fc3
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffff000000) => 0x2cb1dc3a9c72972e425ae2ef3eb597cd
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffff800000) => 0x36aeaa3a213e968d4b5b679d3a2c97fe
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffc00000) => 0x9241daca4fdd034a82372db50e1a0f3f
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffe00000) => 0xc14574d9cd00cf2b5a7f77e53cd57885
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffff00000) => 0x793de39236570aba83ab9b737cb521c9
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffff80000) => 0x16591c0f27d60e29b85a96c33861a7ef
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffc0000) => 0x44fb5c4d4f5cb79be5c174a3b1c97348
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffe0000) => 0x674d2b61633d162be59dde04222f4740
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffff0000) => 0xb4750ff263a65e1f9e924ccfd98f3e37
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffff8000) => 0x62d0662d6eaeddedebae7f7ea3a4f6b6
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffc000) => 0x70c46bb30692be657f7eaa93ebad9897
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffe000) => 0x323994cfb9da285a5d9642e1759b224a
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffff000) => 0x1dbf57877b7b17385c85d0b54851e371
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffff800) => 0xdfa5c097cdc1532ac071d57b1d28d1bd
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffc00) => 0x3a0c53fa37311fc10bd2a9981f513174
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffe00) => 0xba4f970c0a25c41814bdae2e506be3b4
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffff00) => 0x2dce3acb727cd13ccd76d425ea56e4f6
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffff80) => 0x5160474d504b9b3eefb68d35f245f4b3
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffffc0) => 0x41a8a947766635dec37553d9a6c0cbb7
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffffe0) => 0x25d6cfe6881f2bf497dd14cd4ddf445b
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffff0) => 0x41c78c135ed9e98c096640647265da1e
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffff8) => 0x5a4d404d8917e353e92a21072c3b2305
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffffc) => 0x02bc96846b3fdc71643f384cd3cc3eaf
//! assert eval(0x00000000000000000000000000000000, 0xfffffffffffffffffffffffffffffffe) => 0x9ba4a9143f4e5d4048521c4f8877d88e
//! assert eval(0x00000000000000000000000000000000, 0xffffffffffffffffffffffffffffffff) => 0xa1f6258c877d5fcd8964484538bfc92c
//!
//! ## ECB Vary Message
//!
//! assert eval(0x80000000000000000000000000000000, 0x00000000000000000000000000000000) => 0x3ad78e726c1ec02b7ebfe92b23d9ec34
//! assert eval(0xc0000000000000000000000000000000, 0x00000000000000000000000000000000) => 0xaae5939c8efdf2f04e60b9fe7117b2c2
//! assert eval(0xe0000000000000000000000000000000, 0x00000000000000000000000000000000) => 0xf031d4d74f5dcbf39daaf8ca3af6e527
//! assert eval(0xf0000000000000000000000000000000, 0x00000000000000000000000000000000) => 0x96d9fd5cc4f07441727df0f33e401a36
//! assert eval(0xf8000000000000000000000000000000, 0x00000000000000000000000000000000) => 0x30ccdb044646d7e1f3ccea3dca08b8c0
//! assert eval(0xfc000000000000000000000000000000, 0x00000000000000000000000000000000) => 0x16ae4ce5042a67ee8e177b7c587ecc82
//! assert eval(0xfe000000000000000000000000000000, 0x00000000000000000000000000000000) => 0xb6da0bb11a23855d9c5cb1b4c6412e0a
//! assert eval(0xff000000000000000000000000000000, 0x00000000000000000000000000000000) => 0xdb4f1aa530967d6732ce4715eb0ee24b
//! assert eval(0xff800000000000000000000000000000, 0x00000000000000000000000000000000) => 0xa81738252621dd180a34f3455b4baa2f
//! assert eval(0xffc00000000000000000000000000000, 0x00000000000000000000000000000000) => 0x77e2b508db7fd89234caf7939ee5621a
//! assert eval(0xffe00000000000000000000000000000, 0x00000000000000000000000000000000) => 0xb8499c251f8442ee13f0933b688fcd19
//! assert eval(0xfff00000000000000000000000000000, 0x00000000000000000000000000000000) => 0x965135f8a81f25c9d630b17502f68e53
//! assert eval(0xfff80000000000000000000000000000, 0x00000000000000000000000000000000) => 0x8b87145a01ad1c6cede995ea3670454f
//! assert eval(0xfffc0000000000000000000000000000, 0x00000000000000000000000000000000) => 0x8eae3b10a0c8ca6d1d3b0fa61e56b0b2
//! assert eval(0xfffe0000000000000000000000000000, 0x00000000000000000000000000000000) => 0x64b4d629810fda6bafdf08f3b0d8d2c5
//! assert eval(0xffff0000000000000000000000000000, 0x00000000000000000000000000000000) => 0xd7e5dbd3324595f8fdc7d7c571da6c2a
//! assert eval(0xffff8000000000000000000000000000, 0x00000000000000000000000000000000) => 0xf3f72375264e167fca9de2c1527d9606
//! assert eval(0xffffc000000000000000000000000000, 0x00000000000000000000000000000000) => 0x8ee79dd4f401ff9b7ea945d86666c13b
//! assert eval(0xffffe000000000000000000000000000, 0x00000000000000000000000000000000) => 0xdd35cea2799940b40db3f819cb94c08b
//! assert eval(0xfffff000000000000000000000000000, 0x00000000000000000000000000000000) => 0x6941cb6b3e08c2b7afa581ebdd607b87
//! assert eval(0xfffff800000000000000000000000000, 0x00000000000000000000000000000000) => 0x2c20f439f6bb097b29b8bd6d99aad799
//! assert eval(0xfffffc00000000000000000000000000, 0x00000000000000000000000000000000) => 0x625d01f058e565f77ae86378bd2c49b3
//! assert eval(0xfffffe00000000000000000000000000, 0x00000000000000000000000000000000) => 0xc0b5fd98190ef45fbb4301438d095950
//! assert eval(0xffffff00000000000000000000000000, 0x00000000000000000000000000000000) => 0x13001ff5d99806efd25da34f56be854b
//! assert eval(0xffffff80000000000000000000000000, 0x00000000000000000000000000000000) => 0x3b594c60f5c8277a5113677f94208d82
//! assert eval(0xffffffc0000000000000000000000000, 0x00000000000000000000000000000000) => 0xe9c0fc1818e4aa46bd2e39d638f89e05
//! assert eval(0xffffffe0000000000000000000000000, 0x00000000000000000000000000000000) => 0xf8023ee9c3fdc45a019b4e985c7e1a54
//! assert eval(0xfffffff0000000000000000000000000, 0x00000000000000000000000000000000) => 0x35f40182ab4662f3023baec1ee796b57
//! assert eval(0xfffffff8000000000000000000000000, 0x00000000000000000000000000000000) => 0x3aebbad7303649b4194a6945c6cc3694
//! assert eval(0xfffffffc000000000000000000000000, 0x00000000000000000000000000000000) => 0xa2124bea53ec2834279bed7f7eb0f938
//! assert eval(0xfffffffe000000000000000000000000, 0x00000000000000000000000000000000) => 0xb9fb4399fa4facc7309e14ec98360b0a
//! assert eval(0xffffffff000000000000000000000000, 0x00000000000000000000000000000000) => 0xc26277437420c5d634f715aea81a9132
//! assert eval(0xffffffff800000000000000000000000, 0x00000000000000000000000000000000) => 0x171a0e1b2dd424f0e089af2c4c10f32f
//! assert eval(0xffffffffc00000000000000000000000, 0x00000000000000000000000000000000) => 0x7cadbe402d1b208fe735edce00aee7ce
//! assert eval(0xffffffffe00000000000000000000000, 0x00000000000000000000000000000000) => 0x43b02ff929a1485af6f5c6d6558baa0f
//! assert eval(0xfffffffff00000000000000000000000, 0x00000000000000000000000000000000) => 0x092faacc9bf43508bf8fa8613ca75dea
//! assert eval(0xfffffffff80000000000000000000000, 0x00000000000000000000000000000000) => 0xcb2bf8280f3f9742c7ed513fe802629c
//! assert eval(0xfffffffffc0000000000000000000000, 0x00000000000000000000000000000000) => 0x215a41ee442fa992a6e323986ded3f68
//! assert eval(0xfffffffffe0000000000000000000000, 0x00000000000000000000000000000000) => 0xf21e99cf4f0f77cea836e11a2fe75fb1
//! assert eval(0xffffffffff0000000000000000000000, 0x00000000000000000000000000000000) => 0x95e3a0ca9079e646331df8b4e70d2cd6
//! assert eval(0xffffffffff8000000000000000000000, 0x00000000000000000000000000000000) => 0x4afe7f120ce7613f74fc12a01a828073
//! assert eval(0xffffffffffc000000000000000000000, 0x00000000000000000000000000000000) => 0x827f000e75e2c8b9d479beed913fe678
//! assert eval(0xffffffffffe000000000000000000000, 0x00000000000000000000000000000000) => 0x35830c8e7aaefe2d30310ef381cbf691
//! assert eval(0xfffffffffff000000000000000000000, 0x00000000000000000000000000000000) => 0x191aa0f2c8570144f38657ea4085ebe5
//! assert eval(0xfffffffffff800000000000000000000, 0x00000000000000000000000000000000) => 0x85062c2c909f15d9269b6c18ce99c4f0
//! assert eval(0xfffffffffffc00000000000000000000, 0x00000000000000000000000000000000) => 0x678034dc9e41b5a560ed239eeab1bc78
//! assert eval(0xfffffffffffe00000000000000000000, 0x00000000000000000000000000000000) => 0xc2f93a4ce5ab6d5d56f1b93cf19911c1
//! assert eval(0xffffffffffff00000000000000000000, 0x00000000000000000000000000000000) => 0x1c3112bcb0c1dcc749d799743691bf82
//! assert eval(0xffffffffffff80000000000000000000, 0x00000000000000000000000000000000) => 0x00c55bd75c7f9c881989d3ec1911c0d4
//! assert eval(0xffffffffffffc0000000000000000000, 0x00000000000000000000000000000000) => 0xea2e6b5ef182b7dff3629abd6a12045f
//! assert eval(0xffffffffffffe0000000000000000000, 0x00000000000000000000000000000000) => 0x22322327e01780b17397f24087f8cc6f
//! assert eval(0xfffffffffffff0000000000000000000, 0x00000000000000000000000000000000) => 0xc9cacb5cd11692c373b2411768149ee7
//! assert eval(0xfffffffffffff8000000000000000000, 0x00000000000000000000000000000000) => 0xa18e3dbbca577860dab6b80da3139256
//! assert eval(0xfffffffffffffc000000000000000000, 0x00000000000000000000000000000000) => 0x79b61c37bf328ecca8d743265a3d425c
//! assert eval(0xfffffffffffffe000000000000000000, 0x00000000000000000000000000000000) => 0xd2d99c6bcc1f06fda8e27e8ae3f1ccc7
//! assert eval(0xffffffffffffff000000000000000000, 0x00000000000000000000000000000000) => 0x1bfd4b91c701fd6b61b7f997829d663b
//! assert eval(0xffffffffffffff800000000000000000, 0x00000000000000000000000000000000) => 0x11005d52f25f16bdc9545a876a63490a
//! assert eval(0xffffffffffffffc00000000000000000, 0x00000000000000000000000000000000) => 0x3a4d354f02bb5a5e47d39666867f246a
//! assert eval(0xffffffffffffffe00000000000000000, 0x00000000000000000000000000000000) => 0xd451b8d6e1e1a0ebb155fbbf6e7b7dc3
//! assert eval(0xfffffffffffffff00000000000000000, 0x00000000000000000000000000000000) => 0x6898d4f42fa7ba6a10ac05e87b9f2080
//! assert eval(0xfffffffffffffff80000000000000000, 0x00000000000000000000000000000000) => 0xb611295e739ca7d9b50f8e4c0e754a3f
//! assert eval(0xfffffffffffffffc0000000000000000, 0x00000000000000000000000000000000) => 0x7d33fc7d8abe3ca1936759f8f5deaf20
//! assert eval(0xfffffffffffffffe0000000000000000, 0x00000000000000000000000000000000) => 0x3b5e0f566dc96c298f0c12637539b25c
//! assert eval(0xffffffffffffffff0000000000000000, 0x00000000000000000000000000000000) => 0xf807c3e7985fe0f5a50e2cdb25c5109e
//! assert eval(0xffffffffffffffff8000000000000000, 0x00000000000000000000000000000000) => 0x41f992a856fb278b389a62f5d274d7e9
//! assert eval(0xffffffffffffffffc000000000000000, 0x00000000000000000000000000000000) => 0x10d3ed7a6fe15ab4d91acbc7d0767ab1
//! assert eval(0xffffffffffffffffe000000000000000, 0x00000000000000000000000000000000) => 0x21feecd45b2e675973ac33bf0c5424fc
//! assert eval(0xfffffffffffffffff000000000000000, 0x00000000000000000000000000000000) => 0x1480cb3955ba62d09eea668f7c708817
//! assert eval(0xfffffffffffffffff800000000000000, 0x00000000000000000000000000000000) => 0x66404033d6b72b609354d5496e7eb511
//! assert eval(0xfffffffffffffffffc00000000000000, 0x00000000000000000000000000000000) => 0x1c317a220a7d700da2b1e075b00266e1
//! assert eval(0xfffffffffffffffffe00000000000000, 0x00000000000000000000000000000000) => 0xab3b89542233f1271bf8fd0c0f403545
//! assert eval(0xffffffffffffffffff00000000000000, 0x00000000000000000000000000000000) => 0xd93eae966fac46dca927d6b114fa3f9e
//! assert eval(0xffffffffffffffffff80000000000000, 0x00000000000000000000000000000000) => 0x1bdec521316503d9d5ee65df3ea94ddf
//! assert eval(0xffffffffffffffffffc0000000000000, 0x00000000000000000000000000000000) => 0xeef456431dea8b4acf83bdae3717f75f
//! assert eval(0xffffffffffffffffffe0000000000000, 0x00000000000000000000000000000000) => 0x06f2519a2fafaa596bfef5cfa15c21b9
//! assert eval(0xfffffffffffffffffff0000000000000, 0x00000000000000000000000000000000) => 0x251a7eac7e2fe809e4aa8d0d7012531a
//! assert eval(0xfffffffffffffffffff8000000000000, 0x00000000000000000000000000000000) => 0x3bffc16e4c49b268a20f8d96a60b4058
//! assert eval(0xfffffffffffffffffffc000000000000, 0x00000000000000000000000000000000) => 0xe886f9281999c5bb3b3e8862e2f7c988
//! assert eval(0xfffffffffffffffffffe000000000000, 0x00000000000000000000000000000000) => 0x563bf90d61beef39f48dd625fcef1361
//! assert eval(0xffffffffffffffffffff000000000000, 0x00000000000000000000000000000000) => 0x4d37c850644563c69fd0acd9a049325b
//! assert eval(0xffffffffffffffffffff800000000000, 0x00000000000000000000000000000000) => 0xb87c921b91829ef3b13ca541ee1130a6
//! assert eval(0xffffffffffffffffffffc00000000000, 0x00000000000000000000000000000000) => 0x2e65eb6b6ea383e109accce8326b0393
//! assert eval(0xffffffffffffffffffffe00000000000, 0x00000000000000000000000000000000) => 0x9ca547f7439edc3e255c0f4d49aa8990
//! assert eval(0xfffffffffffffffffffff00000000000, 0x00000000000000000000000000000000) => 0xa5e652614c9300f37816b1f9fd0c87f9
//! assert eval(0xfffffffffffffffffffff80000000000, 0x00000000000000000000000000000000) => 0x14954f0b4697776f44494fe458d814ed
//! assert eval(0xfffffffffffffffffffffc0000000000, 0x00000000000000000000000000000000) => 0x7c8d9ab6c2761723fe42f8bb506cbcf7
//! assert eval(0xfffffffffffffffffffffe0000000000, 0x00000000000000000000000000000000) => 0xdb7e1932679fdd99742aab04aa0d5a80
//! assert eval(0xffffffffffffffffffffff0000000000, 0x00000000000000000000000000000000) => 0x4c6a1c83e568cd10f27c2d73ded19c28
//! assert eval(0xffffffffffffffffffffff8000000000, 0x00000000000000000000000000000000) => 0x90ecbe6177e674c98de412413f7ac915
//! assert eval(0xffffffffffffffffffffffc000000000, 0x00000000000000000000000000000000) => 0x90684a2ac55fe1ec2b8ebd5622520b73
//! assert eval(0xffffffffffffffffffffffe000000000, 0x00000000000000000000000000000000) => 0x7472f9a7988607ca79707795991035e6
//! assert eval(0xfffffffffffffffffffffff000000000, 0x00000000000000000000000000000000) => 0x56aff089878bf3352f8df172a3ae47d8
//! assert eval(0xfffffffffffffffffffffff800000000, 0x00000000000000000000000000000000) => 0x65c0526cbe40161b8019a2a3171abd23
//! assert eval(0xfffffffffffffffffffffffc00000000, 0x00000000000000000000000000000000) => 0x377be0be33b4e3e310b4aabda173f84f
//! assert eval(0xfffffffffffffffffffffffe00000000, 0x00000000000000000000000000000000) => 0x9402e9aa6f69de6504da8d20c4fcaa2f
//! assert eval(0xffffffffffffffffffffffff00000000, 0x00000000000000000000000000000000) => 0x123c1f4af313ad8c2ce648b2e71fb6e1
//! assert eval(0xffffffffffffffffffffffff80000000, 0x00000000000000000000000000000000) => 0x1ffc626d30203dcdb0019fb80f726cf4
//! assert eval(0xffffffffffffffffffffffffc0000000, 0x00000000000000000000000000000000) => 0x76da1fbe3a50728c50fd2e621b5ad885
//! assert eval(0xffffffffffffffffffffffffe0000000, 0x00000000000000000000000000000000) => 0x082eb8be35f442fb52668e16a591d1d6
//! assert eval(0xfffffffffffffffffffffffff0000000, 0x00000000000000000000000000000000) => 0xe656f9ecf5fe27ec3e4a73d00c282fb3
//! assert eval(0xfffffffffffffffffffffffff8000000, 0x00000000000000000000000000000000) => 0x2ca8209d63274cd9a29bb74bcd77683a
//! assert eval(0xfffffffffffffffffffffffffc000000, 0x00000000000000000000000000000000) => 0x79bf5dce14bb7dd73a8e3611de7ce026
//! assert eval(0xfffffffffffffffffffffffffe000000, 0x00000000000000000000000000000000) => 0x3c849939a5d29399f344c4a0eca8a576
//! assert eval(0xffffffffffffffffffffffffff000000, 0x00000000000000000000000000000000) => 0xed3c0a94d59bece98835da7aa4f07ca2
//! assert eval(0xffffffffffffffffffffffffff800000, 0x00000000000000000000000000000000) => 0x63919ed4ce10196438b6ad09d99cd795
//! assert eval(0xffffffffffffffffffffffffffc00000, 0x00000000000000000000000000000000) => 0x7678f3a833f19fea95f3c6029e2bc610
//! assert eval(0xffffffffffffffffffffffffffe00000, 0x00000000000000000000000000000000) => 0x3aa426831067d36b92be7c5f81c13c56
//! assert eval(0xfffffffffffffffffffffffffff00000, 0x00000000000000000000000000000000) => 0x9272e2d2cdd11050998c845077a30ea0
//! assert eval(0xfffffffffffffffffffffffffff80000, 0x00000000000000000000000000000000) => 0x088c4b53f5ec0ff814c19adae7f6246c
//! assert eval(0xfffffffffffffffffffffffffffc0000, 0x00000000000000000000000000000000) => 0x4010a5e401fdf0a0354ddbcc0d012b17
//! assert eval(0xfffffffffffffffffffffffffffe0000, 0x00000000000000000000000000000000) => 0xa87a385736c0a6189bd6589bd8445a93
//! assert eval(0xffffffffffffffffffffffffffff0000, 0x00000000000000000000000000000000) => 0x545f2b83d9616dccf60fa9830e9cd287
//! assert eval(0xffffffffffffffffffffffffffff8000, 0x00000000000000000000000000000000) => 0x4b706f7f92406352394037a6d4f4688d
//! assert eval(0xffffffffffffffffffffffffffffc000, 0x00000000000000000000000000000000) => 0xb7972b3941c44b90afa7b264bfba7387
//! assert eval(0xffffffffffffffffffffffffffffe000, 0x00000000000000000000000000000000) => 0x6f45732cf10881546f0fd23896d2bb60
//! assert eval(0xfffffffffffffffffffffffffffff000, 0x00000000000000000000000000000000) => 0x2e3579ca15af27f64b3c955a5bfc30ba
//! assert eval(0xfffffffffffffffffffffffffffff800, 0x00000000000000000000000000000000) => 0x34a2c5a91ae2aec99b7d1b5fa6780447
//! assert eval(0xfffffffffffffffffffffffffffffc00, 0x00000000000000000000000000000000) => 0xa4d6616bd04f87335b0e53351227a9ee
//! assert eval(0xfffffffffffffffffffffffffffffe00, 0x00000000000000000000000000000000) => 0x7f692b03945867d16179a8cefc83ea3f
//! assert eval(0xffffffffffffffffffffffffffffff00, 0x00000000000000000000000000000000) => 0x3bd141ee84a0e6414a26e7a4f281f8a2
//! assert eval(0xffffffffffffffffffffffffffffff80, 0x00000000000000000000000000000000) => 0xd1788f572d98b2b16ec5d5f3922b99bc
//! assert eval(0xffffffffffffffffffffffffffffffc0, 0x00000000000000000000000000000000) => 0x0833ff6f61d98a57b288e8c3586b85a6
//! assert eval(0xffffffffffffffffffffffffffffffe0, 0x00000000000000000000000000000000) => 0x8568261797de176bf0b43becc6285afb
//! assert eval(0xfffffffffffffffffffffffffffffff0, 0x00000000000000000000000000000000) => 0xf9b0fda0c4a898f5b9e6f661c4ce4d07
//! assert eval(0xfffffffffffffffffffffffffffffff8, 0x00000000000000000000000000000000) => 0x8ade895913685c67c5269f8aae42983e
//! assert eval(0xfffffffffffffffffffffffffffffffc, 0x00000000000000000000000000000000) => 0x39bde67d5c8ed8a8b1c37eb8fa9f5ac0
//! assert eval(0xfffffffffffffffffffffffffffffffe, 0x00000000000000000000000000000000) => 0x5c005e72c1418c44f569f2ea33ba54f3
//! assert eval(0xffffffffffffffffffffffffffffffff, 0x00000000000000000000000000000000) => 0x3f5b8cc9ea855a0afa7347d23e8d664e
//!
//! ## ECB S-Box Keys
//!
//! assert eval(0x00000000000000000000000000000000, 0x10a58869d74be5a374cf867cfb473859) => 0x6d251e6944b051e04eaa6fb4dbf78465
//! assert eval(0x00000000000000000000000000000000, 0xcaea65cdbb75e9169ecd22ebe6e54675) => 0x6e29201190152df4ee058139def610bb
//! assert eval(0x00000000000000000000000000000000, 0xa2e2fa9baf7d20822ca9f0542f764a41) => 0xc3b44b95d9d2f25670eee9a0de099fa3
//! assert eval(0x00000000000000000000000000000000, 0xb6364ac4e1de1e285eaf144a2415f7a0) => 0x5d9b05578fc944b3cf1ccf0e746cd581
//! assert eval(0x00000000000000000000000000000000, 0x64cf9c7abc50b888af65f49d521944b2) => 0xf7efc89d5dba578104016ce5ad659c05
//! assert eval(0x00000000000000000000000000000000, 0x47d6742eefcc0465dc96355e851b64d9) => 0x0306194f666d183624aa230a8b264ae7
//! assert eval(0x00000000000000000000000000000000, 0x3eb39790678c56bee34bbcdeccf6cdb5) => 0x858075d536d79ccee571f7d7204b1f67
//! assert eval(0x00000000000000000000000000000000, 0x64110a924f0743d500ccadae72c13427) => 0x35870c6a57e9e92314bcb8087cde72ce
//! assert eval(0x00000000000000000000000000000000, 0x18d8126516f8a12ab1a36d9f04d68e51) => 0x6c68e9be5ec41e22c825b7c7affb4363
//! assert eval(0x00000000000000000000000000000000, 0xf530357968578480b398a3c251cd1093) => 0xf5df39990fc688f1b07224cc03e86cea
//! assert eval(0x00000000000000000000000000000000, 0xda84367f325d42d601b4326964802e8e) => 0xbba071bcb470f8f6586e5d3add18bc66
//! assert eval(0x00000000000000000000000000000000, 0xe37b1c6aa2846f6fdb413f238b089f23) => 0x43c9f7e62f5d288bb27aa40ef8fe1ea8
//! assert eval(0x00000000000000000000000000000000, 0x6c002b682483e0cabcc731c253be5674) => 0x3580d19cff44f1014a7c966a69059de5
//! assert eval(0x00000000000000000000000000000000, 0x143ae8ed6555aba96110ab58893a8ae1) => 0x806da864dd29d48deafbe764f8202aef
//! assert eval(0x00000000000000000000000000000000, 0xb69418a85332240dc82492353956ae0c) => 0xa303d940ded8f0baff6f75414cac5243
//! assert eval(0x00000000000000000000000000000000, 0x71b5c08a1993e1362e4d0ce9b22b78d5) => 0xc2dabd117f8a3ecabfbb11d12194d9d0
//! assert eval(0x00000000000000000000000000000000, 0xe234cdca2606b81f29408d5f6da21206) => 0xfff60a4740086b3b9c56195b98d91a7b
//! assert eval(0x00000000000000000000000000000000, 0x13237c49074a3da078dc1d828bb78c6f) => 0x8146a08e2357f0caa30ca8c94d1a0544
//! assert eval(0x00000000000000000000000000000000, 0x3071a2a48fe6cbd04f1a129098e308f8) => 0x4b98e06d356deb07ebb824e5713f7be3
//! assert eval(0x00000000000000000000000000000000, 0x90f42ec0f68385f2ffc5dfc03a654dce) => 0x7a20a53d460fc9ce0423a7a0764c6cf2
//! assert eval(0x00000000000000000000000000000000, 0xfebd9a24d8b65c1c787d50a4ed3619a9) => 0xf4a70d8af877f9b02b4c40df57d45b17
//!
//! ## ECB S-Box Messages
//!
//! assert eval(0xf34481ec3cc627bacd5dc3fb08f273e6, 0x00000000000000000000000000000000) => 0x0336763e966d92595a567cc9ce537f5e
//! assert eval(0x9798c4640bad75c7c3227db910174e72, 0x00000000000000000000000000000000) => 0xa9a1631bf4996954ebc093957b234589
//! assert eval(0x96ab5c2ff612d9dfaae8c31f30c42168, 0x00000000000000000000000000000000) => 0xff4f8391a6a40ca5b25d23bedd44a597
//! assert eval(0x6a118a874519e64e9963798a503f1d35, 0x00000000000000000000000000000000) => 0xdc43be40be0e53712f7e2bf5ca707209
//! assert eval(0xcb9fceec81286ca3e989bd979b0cb284, 0x00000000000000000000000000000000) => 0x92beedab1895a94faa69b632e5cc47ce
//! assert eval(0xb26aeb1874e47ca8358ff22378f09144, 0x00000000000000000000000000000000) => 0x459264f4798f6a78bacb89c15ed3d601
//! assert eval(0x58c8e00b2631686d54eab84b91f0aca1, 0x00000000000000000000000000000000) => 0x08a4e2efec8a8e3312ca7460b9040bbf
//!
//! use aes128

use crate::valid::aes128::aes128;
use pbc_zk::Sbu1;

pub fn test(mut m: [Sbu1; 128], mut k: [Sbu1; 128]) -> [Sbu1; 128] {
    aes128(m, k)
}
